package com.allpayx.atsmpservice.common;


import com.allpayx.atsmpservice.exception.CheckException;
import com.allpayx.atsmpservice.param.RequestParam.RecoredConfirmInfoRequest;
import org.apache.commons.lang.StringUtils;


import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class CommonMethod {
    public static void vertifyReceiveDate(RecoredConfirmInfoRequest voucherLog){
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        if(StringUtils.isNotBlank(voucherLog.getReceive_start_date())){
            String TheDayBeforeStartDate = null;
            try {
                TheDayBeforeStartDate = dateFormat.format(addAndSubtractDaysByCalendar(dateFormat.parse(voucherLog.getReceive_start_date()),0));
            } catch (ParseException e) {
                e.printStackTrace();
                throw  new CheckException("日期转换时发生异常");
            }
            voucherLog.setReceive_start_date(TheDayBeforeStartDate);
        }
        if(StringUtils.isNotBlank(voucherLog.getReceive_end_date() )){
            String TheDayBeforeEndDate = null;
            try {
                TheDayBeforeEndDate = dateFormat.format(addAndSubtractDaysByCalendar(dateFormat.parse(voucherLog.getReceive_end_date()),1));
            } catch (ParseException e) {
                e.printStackTrace();
                throw  new CheckException("日期转换时发生异常");
            }
            voucherLog.setReceive_end_date(TheDayBeforeEndDate);
        }
    }
    public static void vertifyRecoredDate(RecoredConfirmInfoRequest voucherLog){
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        if(StringUtils.isNotBlank(voucherLog.getEntry_start_date())){
            String TheDayBeforeStartDate = null;
            try {
                TheDayBeforeStartDate = dateFormat.format(addAndSubtractDaysByCalendar(dateFormat.parse(voucherLog.getEntry_start_date()),0));
            } catch (ParseException e) {
                e.printStackTrace();
                throw  new CheckException("日期转换时发生异常");
            }
            voucherLog.setEntry_start_date(TheDayBeforeStartDate);
        }
        if(StringUtils.isNotBlank(voucherLog.getEntry_end_date())){
            String TheDayBeforeEndDate = null;
            try {
                TheDayBeforeEndDate = dateFormat.format(addAndSubtractDaysByCalendar(dateFormat.parse(voucherLog.getEntry_end_date()),1));
            } catch (ParseException e) {
                e.printStackTrace();
                throw  new CheckException("日期转换时发生异常");
            }
            voucherLog.setEntry_end_date(TheDayBeforeEndDate);
        }
    }
    //对传入的日期进行加减
    public static Date addAndSubtractDaysByCalendar(Date dateTime/*待处理的日期*/, int n/*加减天数*/){
        //日期格式
        SimpleDateFormat df=new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat dd=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Calendar calstart = Calendar.getInstance();
        calstart.setTime(dateTime);
        calstart.add(Calendar.DAY_OF_WEEK, n);
        return calstart.getTime();
    }
}
